diff --git a/src/cdogs/game_events.c b/src/cdogs/game_events.c
index 9badf371e..d5830b01e 100644
--- a/src/cdogs/game_events.c
+++ b/src/cdogs/game_events.c
@@ -71,6 +71,7 @@ static GameEventEntry sGameEventEntries[] =
 	{ GAME_EVENT_SET_MESSAGE, false, false, true, true, NULL },
 
 	{ GAME_EVENT_GAME_START, true, false, true, true, NULL },
+	{ GAME_EVENT_GAME_BEGIN, true, false, true, true, NULL },
 
 	{ GAME_EVENT_ACTOR_ADD, true, false, true, true, NActorAdd_fields },
 	{ GAME_EVENT_ACTOR_MOVE, true, true, true, true, NActorMove_fields },
diff --git a/src/cdogs/game_events.h b/src/cdogs/game_events.h
index 432612060..1602998f1 100644
--- a/src/cdogs/game_events.h
+++ b/src/cdogs/game_events.h
@@ -62,6 +62,7 @@ typedef enum
 	// Use to signal start of game; useless for single player,
 	// but for networked games it's used to set game ticks 0
 	GAME_EVENT_GAME_START,
+	GAME_EVENT_GAME_BEGIN,
 
 	GAME_EVENT_ACTOR_ADD,
 	GAME_EVENT_ACTOR_MOVE,
diff --git a/src/cdogs/handle_game_events.c b/src/cdogs/handle_game_events.c
index 789bee183..000f74a11 100644
--- a/src/cdogs/handle_game_events.c
+++ b/src/cdogs/handle_game_events.c
@@ -146,6 +146,10 @@ static void HandleGameEvent(
 		break;
 	case GAME_EVENT_GAME_START:
 		gMission.HasStarted = true;
+		gMission.HasBegun = false;
+		break;
+	case GAME_EVENT_GAME_BEGIN:
+		MissionBegin(&gMission);
 		break;
 	case GAME_EVENT_ACTOR_ADD:
 		ActorAdd(e.u.ActorAdd);
diff --git a/src/cdogs/hud.c b/src/cdogs/hud.c
index 26e94e66d..2c1fc59c9 100644
--- a/src/cdogs/hud.c
+++ b/src/cdogs/hud.c
@@ -907,30 +907,39 @@ void HUDDraw(
 		DrawSharedRadar(hud->device, RADAR_SCALE, hud->showExit);
 	}
 
-	if (numPlayersAlive == 0)
+	switch (hud->mission->state)
 	{
-		if (AreAllPlayersDeadAndNoLives())
-		{
-			if (gPlayerDatas.size == 0)
-			{
-				FontStrCenter("Waiting for players...");
-			}
-			else if (!IsPVP(gCampaign.Entry.Mode))
-			{
-				FontStrCenter("Game Over!");
-			}
-			else
+		case MISSION_STATE_WAITING:
+			FontStrCenter("Waiting for players...");
+			break;
+		case MISSION_STATE_PLAY:
+			if (numPlayersAlive == 0)
 			{
-				FontStrCenter("All Kill!");
+				if (AreAllPlayersDeadAndNoLives())
+				{
+					if (gPlayerDatas.size == 0)
+					{
+						FontStrCenter("Waiting for players...");
+					}
+					else if (!IsPVP(gCampaign.Entry.Mode))
+					{
+						FontStrCenter("Game Over!");
+					}
+					else
+					{
+						FontStrCenter("All Kill!");
+					}
+				}
 			}
+			break;
+		case MISSION_STATE_PICKUP:
+		{
+			int timeLeft = gMission.pickupTime + PICKUP_LIMIT - gMission.time;
+			sprintf(s, "Pickup in %d seconds\n",
+				(timeLeft + (FPS_FRAMELIMIT - 1)) / FPS_FRAMELIMIT);
+			FontStrCenter(s);
 		}
-	}
-	else if (hud->mission->state == MISSION_STATE_PICKUP)
-	{
-		int timeLeft = gMission.pickupTime + PICKUP_LIMIT - gMission.time;
-		sprintf(s, "Pickup in %d seconds\n",
-			(timeLeft + (FPS_FRAMELIMIT - 1)) / FPS_FRAMELIMIT);
-		FontStrCenter(s);
+		break;
 	}
 
 	if (controllerUnplugged)
diff --git a/src/cdogs/mission.c b/src/cdogs/mission.c
index e23750ce4..9a1959992 100644
--- a/src/cdogs/mission.c
+++ b/src/cdogs/mission.c
@@ -58,6 +58,7 @@
 #include "gamedata.h"
 #include "map.h"
 #include "map_new.h"
+#include "music.h"
 #include "net_util.h"
 #include "objs.h"
 #include "palette.h"
@@ -327,6 +328,7 @@ void MissionEnd(void)
 		p->ActorUID = -1;
 	CA_FOREACH_END()
 	gMission.HasStarted = false;
+	gMission.HasBegun = false;
 }
 
 void MissionSetMessageIfComplete(struct MissionOptions *options)
@@ -369,8 +371,44 @@ void UpdateMissionObjective(
 	}
 }
 
+bool MissionCanBegin(void)
+{
+	// Need at least two players to begin PVP
+	if (IsPVP(gCampaign.Entry.Mode))
+	{
+		return GetNumPlayers(PLAYER_ALIVE_OR_DYING, false, false) > 1;
+	}
+	// Otherwise, just one player will do
+	return GetNumPlayers(PLAYER_ALIVE_OR_DYING, false, false) > 0;
+}
+
+void MissionBegin(struct MissionOptions *m)
+{
+	m->HasBegun = true;
+	m->state = MISSION_STATE_PLAY;
+	MusicPlayGame(&gSoundDevice, gCampaign.Entry.Path, m->missionData->Song);
+	if (MusicGetStatus(&gSoundDevice) == MUSIC_NOLOAD)
+	{
+		// Display music error message for 2 seconds
+		GameEvent e = GameEventNew(GAME_EVENT_SET_MESSAGE);
+		strncat(
+			e.u.SetMessage.Message, MusicGetErrorMessage(&gSoundDevice),
+			sizeof e.u.SetMessage.Message - 1);
+		e.u.SetMessage.Ticks = FPS_FRAMELIMIT * 2;
+		GameEventsEnqueue(&gGameEvents, e);
+	}
+	m->time = 0;
+	m->pickupTime = 0;
+}
+
 bool CanCompleteMission(const struct MissionOptions *options)
 {
+	// Can't complete if not started yet
+	if (!options->HasBegun)
+	{
+		return false;
+	}
+
 	// Death is the only escape from PVP and quick play
 	if (IsPVP(gCampaign.Entry.Mode))
 	{
diff --git a/src/cdogs/mission.h b/src/cdogs/mission.h
index 739e69f46..cbc200647 100644
--- a/src/cdogs/mission.h
+++ b/src/cdogs/mission.h
@@ -22,7 +22,7 @@
     This file incorporates work covered by the following copyright and
     permission notice:
 
-    Copyright (c) 2013-2015, Cong Xu
+    Copyright (c) 2013-2016, Cong Xu
     All rights reserved.
 
     Redistribution and use in source and binary forms, with or without
@@ -201,6 +201,7 @@ typedef struct
 
 typedef enum
 {
+	MISSION_STATE_WAITING,
 	MISSION_STATE_PLAY,
 	MISSION_STATE_PICKUP
 } MissionState;
@@ -217,7 +218,10 @@ struct MissionOptions
 	// Time when players first entered pickup area
 	int pickupTime;
 	MissionState state;
+	// Whether the mission has loaded
 	bool HasStarted;
+	// Whether the mission has begun (can complete objectives etc.)
+	bool HasBegun;
 	bool isDone;
 
 	int keyStyle;
@@ -237,6 +241,8 @@ void MissionSetMessageIfComplete(struct MissionOptions *options);
 void UpdateMissionObjective(
 	const struct MissionOptions *options,
 	const int flags, const ObjectiveType type);
+bool MissionCanBegin(void);
+void MissionBegin(struct MissionOptions *m);
 bool CanCompleteMission(const struct MissionOptions *options);
 bool IsMissionComplete(const struct MissionOptions *options);
 bool MissionHasRequiredObjectives(const struct MissionOptions *mo);
diff --git a/src/cdogs/net_server.c b/src/cdogs/net_server.c
index 30a63ed4d..29c0c67c4 100644
--- a/src/cdogs/net_server.c
+++ b/src/cdogs/net_server.c
@@ -329,6 +329,10 @@ static void OnReceive(NetServer *n, ENetEvent event)
 					}
 				}
 			}
+			if (gMission.HasBegun)
+			{
+				NetServerSendMsg(n, peerId, GAME_EVENT_GAME_BEGIN, NULL);
+			}
 
 			NetServerFlush(n);
 			break;
diff --git a/src/game.c b/src/game.c
index 1248fe0ec..198d108db 100644
--- a/src/game.c
+++ b/src/game.c
@@ -213,7 +213,6 @@ bool RunGame(const CampaignOptions *co, struct MissionOptions *m, Map *map)
 			CreateEnemies();
 		}
 	}
-	MusicPlayGame(&gSoundDevice, co->Entry.Path, m->missionData->Song);
 
 	RunGameData data;
 	memset(&data, 0, sizeof data);
@@ -238,20 +237,7 @@ bool RunGame(const CampaignOptions *co, struct MissionOptions *m, Map *map)
 		CArrayPushBack(&data.ammoSpawners, &ps);
 	}
 
-	if (MusicGetStatus(&gSoundDevice) == MUSIC_NOLOAD)
-	{
-		// Display music error message for 2 seconds
-		GameEvent e = GameEventNew(GAME_EVENT_SET_MESSAGE);
-		strncat(
-			e.u.SetMessage.Message, MusicGetErrorMessage(&gSoundDevice),
-			sizeof e.u.SetMessage.Message - 1);
-		e.u.SetMessage.Ticks = FPS_FRAMELIMIT * 2;
-		GameEventsEnqueue(&gGameEvents, e);
-	}
-
-	m->time = 0;
-	m->pickupTime = 0;
-	m->state = MISSION_STATE_PLAY;
+	m->state = MISSION_STATE_WAITING;
 	m->isDone = false;
 	Pic *crosshair = PicManagerGetPic(&gPicManager, "crosshair");
 	crosshair->offset.x = -crosshair->size.x / 2;
@@ -264,9 +250,6 @@ bool RunGame(const CampaignOptions *co, struct MissionOptions *m, Map *map)
 	GameEvent start = GameEventNew(GAME_EVENT_GAME_START);
 	GameEventsEnqueue(&gGameEvents, start);
 
-	// Set mission complete and display exit if it is complete
-	MissionSetMessageIfComplete(m);
-
 	data.loop = GameLoopDataNew(
 		&data, RunGameUpdate, &data, RunGameDraw);
 	data.loop.InputData = &data;
@@ -418,6 +401,16 @@ static GameLoopResult RunGameUpdate(void *data)
 		return UPDATE_RESULT_EXIT;
 	}
 
+	// Check if game can begin
+	if (!rData->m->HasBegun && MissionCanBegin())
+	{
+		GameEvent begin = GameEventNew(GAME_EVENT_GAME_BEGIN);
+		GameEventsEnqueue(&gGameEvents, begin);
+
+		// Set mission complete and display exit if it is complete
+		MissionSetMessageIfComplete(rData->m);
+	}
+
 	// If we're not hosting a net game,
 	// don't update if the game has paused or has automap shown
 	// Important: don't consider paused if we are trying to quit
